#!/usr/bin/python

import sys
import os
import shutil
from optparse import OptionParser
from blist import blist
import re
import common


PERIODOCREAFICHERO=20000000

TAMHISTOREPE=4000

TAM_HISTO_DISTT=2000000000
PASOS_HISTO_DISTT=500000

UMBRALAR=200  # num de repeticiones para generar el histograma de distancia AR

#
# Funciones de analisis
#


#
#
# Leo fichero e integro en bagOfLines
# Rapidisimo pero ocupa mucha memoria
def LeeFichero():
  print "Leyendo fichero ", datFile
  with open(datFile) as fp:
    cnt = 0
    for line in fp:
#        print ("line {} contents {}".format(cnt,line))
        cols = line.split(" ")
        tam = len(cols)-2  # uno lo quitamos por el barra-n y otro por tag
        tag = cols[0]
        lista=[]
        for i in range(1,tam,2):
          ciclos = cols[i]
          tipo = cols[i+1]
          lista.append([ciclos,tipo])
#          print " ciclos:", ciclos, " tipo:", tipo
        bagOfLines.append([tag,lista])

        cnt+=1

def echo():
    for i in range(0, len(bagOfLines)):
        tag,lista=bagOfLines[i]
        string=tag
        for j in range(0,len(lista)):
          ciclos,tipo=lista[j]
          string=string+" "+ciclos+" "+tipo
        print string


def histogramaRepeticion():
    print "Generando histograma repeticion"
    # Inicializacion histograma
    for i in range(1,TAMHISTOREPE):
        histoRepe[i]=0

    for i in range(0, len(bagOfLines)):
        tag,lista=bagOfLines[i]
#        string=tag
        tam=len(lista)
#        string=string+" repe:"+str(tam)
#        print string
        if tam < TAMHISTOREPE-1:
          histoRepe[tam]+=1
        else:
          histoRepe[TAMHISTOREPE-1]+=1


def printHistogramaRepeticion():
    string="HistogramaRepeticion: (Ultimo: "+str(TAMHISTOREPE)+" +) "
    for i in range(1,TAMHISTOREPE):
      string=string+str(histoRepe[i])+" "

    salidaS.write(string)
    salidaS.write("\n")


# Histograma de distancia temporal entre dos accesos consecutivos a la misma linea
def histogramaDistTemporal():
    print "Generando histograma distancia temporal"
    NumEle=TAM_HISTO_DISTT/PASOS_HISTO_DISTT
    # Inicializacion histograma
    for i in range(0,NumEle):
        histoDistT[i]=0

    cnt=0
    for i in range(0, len(bagOfLines)):
        tag,lista=bagOfLines[i]
#        string=tag
        cnt+=1
        if cnt%1000000==0:
          print "Cnt: ",cnt
        tam=len(lista)
        if tam>1:
          for j in range(1, tam):
            ciclos2,tipo2=lista[j]
            ciclos1,tipo1=lista[j-1]
            try:
              dif=long(ciclos2)-long(ciclos1)
            except ValueError:
                print "ValueError en ciclos. tag: ",tag
                dif=0
                break
            dif=dif/PASOS_HISTO_DISTT
#            print "dif:", dif
            if dif>=0 and dif<NumEle-1:
                histoDistT[dif]+=1
            elif dif>=0:
                histoDistT[NumEle-1]+=1
            else:
                print "Ciclos desordenados. tag: ", tag
          

def printHistogramaDistTemporal():
    NumEle=TAM_HISTO_DISTT/PASOS_HISTO_DISTT
    string="HistogramaDistanciaTemporal (Paso: " +str(PASOS_HISTO_DISTT)+ " Ultimo: "+str(TAM_HISTO_DISTT)+" +) "
    for i in range(0,NumEle):
      string=string+str(histoDistT[i])+" "

    salidaS.write(string)
    salidaS.write("\n")



# Histograma de distancia temporal entre dos accesos consecutivos a la misma linea
# AR=Alta Repeticion. Solo con lineas con mas de UMBRALAR repeticiones
def histogramaDistTemporalAR():
    print "Generando histograma distancia temporal AR (alta repeticion)"
    NumEle=TAM_HISTO_DISTT/PASOS_HISTO_DISTT
    # Inicializacion histograma
    for i in range(0,NumEle):
        histoDistTAR[i]=0

    cnt=0
    for i in range(0, len(bagOfLines)):
        tag,lista=bagOfLines[i]
#        string=tag
        cnt+=1
        if cnt%1000000==0:
          print "Cnt: ",cnt
        tam=len(lista)
        if tam>UMBRALAR:
          for j in range(1, tam):
            ciclos2,tipo2=lista[j]
            ciclos1,tipo1=lista[j-1]
            try:
              dif=long(ciclos2)-long(ciclos1)
            except ValueError:
                print "ValueError en ciclos. tag: ",tag
                dif=0
                break
            dif=dif/PASOS_HISTO_DISTT
#            print "dif:", dif
            if dif>=0 and dif<NumEle-1:
                histoDistTAR[dif]+=1
            elif dif>=0:
                histoDistTAR[NumEle-1]+=1
            else:
                print "Ciclos desordenados. tag: ", tag
          

def printHistogramaDistTemporalAR():
    NumEle=TAM_HISTO_DISTT/PASOS_HISTO_DISTT
    string="HistogramaDistanciaTemporalAR (Paso: " +str(PASOS_HISTO_DISTT)+ " Ultimo: "+str(TAM_HISTO_DISTT)+" + UmbralReps: "+ str(UMBRALAR)+" ) "
    for i in range(0,NumEle):
      string=string+str(histoDistTAR[i])+" "

    salidaS.write(string)
    salidaS.write("\n")





parser = OptionParser()
parser.add_option("--ficheroOut",action="store",dest="fichO",default="NONE",
            help="name of out file")

parser.add_option("-s","--ficheroStat",action="store",dest="salidaS",default="NONE",
            help="name of folder in which to generate stat result file")


(options,args) = parser.parse_args(sys.argv[1:])

salidaStat = options.salidaS
datFile = options.fichO



if salidaStat=="NONE" or datFile=="NONE":
    print ("nvt2out.py --ficheroOut=FicheroOut.out --ficheroStat=FicheroEstadisticas.stat")
    sys.exit(0)

if not os.path.isfile(datFile):
    print ("File ", datFile, " no existe")
    sys.exit(0)

print ("Fichero datos out:" , datFile)
print ("Fichero Salida:" , salidaStat)

salidaS = file(salidaStat, "w")

# Diccionario
bagOfLines=[]

# Uso blist
#bagOfLines=blist([])

# Histogramas
histoRepe={}
histoDistT={}
histoDistTAR={}

#Version con Diccionario y mucho consumo de memoria (poco tiempo)
LeeFichero()
#echo()
histogramaRepeticion()
printHistogramaRepeticion()
histogramaDistTemporal()
printHistogramaDistTemporal()
histogramaDistTemporalAR()
printHistogramaDistTemporalAR()


sys.exit(0)




