#!/usr/bin/python

import sys
import os
import shutil
from optparse import OptionParser
from blist import blist
import re
import common


PERIODOCREAFICHERO=20000000


# CiclosPorIntervalo indica el tamano del intervalo para medir OPKC
CiclosPorIntervalo=50000
# CiclosPorSeccion indica el valor del intervalo para detectar una seccion
CiclosPorSeccion=1000000




#
#
#
# Devuelve numOperaciones,ciclosTotales
# Incluye RE
def Cuenta():
  print "Lee nvt y cuenta numOp y ciclos"

  numOp=0

  line=tFile.readline()
  while line:
      numOp+=1
      cols=line.split(" ")
      ciclos=int(cols[0])
      line=tFile.readline()
      if numOp%1000000 == 0:
          print "Leidas ", numOp, " operaciones"

  return numOp, ciclos

# Igual que Cuenta pero desde la pos actual hasta MaxCiclos
def CuentaC(MaxCiclos):

  numOp=0
  ciclos=0

  line=tFile.readline()
  while line and (ciclos<MaxCiclos):
      numOp+=1
      cols=line.split(" ")
      ciclos=int(cols[0])
      line=tFile.readline()

  return numOp

def BuscaSecciones():

  NumIntervalos=ciclosTot/CiclosPorIntervalo

  NumRepes={}
  OpkcIntervalo={}

  TamNumRepes=CiclosPorSeccion/CiclosPorIntervalo

  for i in range(0,TamNumRepes):
    NumRepes[i]=0
    OpkcIntervalo[i]=0



  iniCluster=0
  cnt=0
  for i in range(0,NumIntervalos):
    Operaciones=CuentaC(CiclosPorIntervalo*(i+1))
    OPKCi= float(Operaciones)*1000.0/float(CiclosPorIntervalo)
    if OPKCi>=limMax:
      if iniCluster==0:
        iniCluster=1
        iniCiclo=(CiclosPorIntervalo*i)/1000000.0
        OPKCiInt= OPKCi
        cnt=1
      elif iniCluster==1:
        OPKCiInt+=OPKCi
        cnt+=1
    else:
      if iniCluster==1:
        iniCluster=0
        finCiclo=(CiclosPorIntervalo*(i+1))/1000000.0
        OPKCiInt=OPKCiInt/cnt
        if cnt<TamNumRepes:
          NumRepes[cnt-1]+=1
          OpkcIntervalo[cnt-1]+=OPKCiInt
        else:
          NumRepes[TamNumRepes-1]+=1
          OpkcIntervalo[TamNumRepes-1]+=OPKCiInt
#          print "Seccion.CicloInicial(MCycle)=", iniCiclo, "CicloFinal=", finCiclo, "OPKCiIntervalo=", OPKCiInt, "TamSeccion=", cnt*CiclosPorIntervalo/1000000.0
#          string= "Seccion.CicloInicial(MCycle)= "+ str(iniCiclo)+ " CicloFinal= "+ str(finCiclo)+ " OPKCiIntervalo= "+ str(OPKCiInt)+ " TamSeccion= "+ str(cnt*CiclosPorIntervalo/1000000.0)
#          salidaS.write(string)
#          salidaS.write("\n")
#  if OPKCi<=limMin:
#      print "Seccion. Ciclo=", (ciclosPorIntervalo*i), "OPKCi=", OPKCi
    if ((i%10000)==0):
        print "MCiclos tratados: ", CiclosPorIntervalo*(i+1)/1000000, " MCiclos totales: ", ciclosTot/1000000

  string=" "
  for i in range(0,TamNumRepes):
    if NumRepes[i]>0:
      string+=str(NumRepes[i])+"-"+str(int(float(OpkcIntervalo[i])/float(NumRepes[i])))+" "
    else:
      string+=str(NumRepes[i])+"-0 "
  salidaS.write(string)






parser = OptionParser()
parser.add_option("--ficheroTraza",action="store",dest="traceF",default="NONE",
            help="name of trace file")

parser.add_option("-s","--ficheroSalida",action="store",dest="salidaF",default="NONE",
            help="name of temporal stat file")


(options,args) = parser.parse_args(sys.argv[1:])

salidaFile = options.salidaF
traceFile = options.traceF



print ("Fichero Traza:" , traceFile)
print ("Fichero Salida:" , salidaFile)
if traceFile=="NONE" or salidaFile=="NONE":
    print ("nvt2statS.py --ficheroTraza=FicheroTraza --ficheroSalida=FicheroSalidaStatS")
    sys.exit(0)

if not os.path.isfile(traceFile):
    print ("File ", traceFile, " no existe")
    sys.exit(0)

tFile = file(traceFile, "r")
salidaS = file(salidaFile, "w")




#Version con listas y poco consumo de memoria. Uso blist. Rapido pero necesita mucha memoria
Operaciones,ciclosTot=Cuenta()
opkc=float(Operaciones)*1000.0/float(ciclosTot)
#print "Op=", Operaciones, " ciclosTot=", ciclosTot, "OPKC=", opkc
string= "OperacionesTotales= "+ str(Operaciones)+ " ciclosTotales= "+ str(ciclosTot)+ " OPKC= "+ str(opkc)
salidaS.write(string)
salidaS.write("\n")


limMax=opkc*10.0
limMin=opkc/10.0

string="NumeroDeSeccionesConAltaDensidad-OPKC (Ini+paso= "+str(CiclosPorIntervalo) + " Ciclos) "
salidaS.write(string)

tFile.close()
tFile=file(traceFile, "r")

BuscaSecciones()



#imprimeFicheroStat(LineasLeidas)

sys.exit(0)




