#!/usr/bin/python

import sys
import os
import shutil
from optparse import OptionParser
from blist import blist
import re
import common


PERIODOCREAFICHERO=20000000


#
# Funciones de analisis
#
def InsertaTag(ciclos, tag, tipo):
    if tag in bagOfLines:
        bagOfLines[tag][ciclos]=tipo
    else:
        bagOfLines[tag] = {}
        bagOfLines[tag][ciclos]=tipo

def RecorreTag(fichero):
    outputFile = file(fichero,"w")
    print ("RECORRE TAG")
    for tag, entradas in bagOfLines.items():
        cnt=0
        string= tag+" "   
        for listaCiclos in sorted(entradas.items()):
#            print "listaCiclos: ", listaCiclos
            ciclos,tipo=listaCiclos
            string=string+ciclos+" "+tipo+" "
        string=string+"\n"
#        print string
        outputFile.write(string)

    outputFile.close()

#
#
# Leo fichero e integro en bagOfLines
# Rapidisimo pero ocupa mucha memoria
def LeeFichero():
  with open(traceFile) as fp:
    cnt = 0
    for line in fp:
#        print ("line {} contents {}".format(cnt,line))
        cols = line.split(" ")
        ciclos = cols[0]
        tag = cols[2]
        tipo = cols[1]
#        print "Linea:", cnt, " Ciclos:", ciclos, " Tag:", tag, " Tipo:", tipo

        InsertaTag(ciclos, tag, tipo)
        cnt+=1

#
#
#
# Leo fichero e integro en vectorTags
# Muy lento. Funciona hasta 100000 lineas. Luego empieza a tardar siglos
def LeeFicheroAhorroMem():
  print ("LEE FICHERO CON AHORR MEMORIA (LEEENTO)")

  with open(traceFile) as fp:
    cnt = 0
    for line in fp:
#        print ("line {} contents {}".format(cnt,line))
        cols = line.split(" ")
        ciclos = cols[0]
        tag = cols[2]
        tipo = cols[1]
#        print "Linea:", cnt, " Ciclos:", ciclos, " Tag:", tag, " Tipo:", tipo
        fin=0
        # busca tag en la lista
        for tagT,datosT in vectorTags:
          if tag==tagT:
#            print "repe"
            datosT.append([ciclos,tipo])
            fin=1
            break
      
      # tag no aparece en la lista: se annade
        if fin==0:
          datos=[]
          datos.append([ciclos,tipo])
          vectorTags.append([tag,datos])

        cnt+=1
        if cnt%1000==0:
            print ("Lineas tratadas: ", cnt)

def RecorreTagAhorroMem(fichero):
    outputFile = file(fichero,"w")
    print ("RECORRE TAG AHORRO MEM")
    for tag,entradas in vectorTags:
        string= tag+" "   
        for ciclos,tipo in entradas:
          string=string+ciclos+" "+tipo+" "
        string=string+"\n"
#        print string
        outputFile.write(string)

    outputFile.close()








#
#
#
# Leo fichero e integro en vectorTags
# 

def LeeFicheroAhorroMem2():
  print ("LEE FICHERO CON AHORR MEMORIA 2")

  with open(traceFile) as fp:
    cnt = 0
    numFiles=0
    for line in fp:
#        print ("line {} contents {}".format(cnt,line))
        cols = line.split(" ")
        ciclos = cols[0]
        tag = cols[2]
        tipo = cols[1]
#        print "Linea:", cnt, " Ciclos:", ciclos, " Tag:", tag, " Tipo:", tipo
        fin=0
        # busca tag en la lista
        if tag in bagOfLines:
          entrada=bagOfLines[tag]
          tagT,datosT = vectorTags[entrada]
          datosT.append([ciclos,tipo])
        else:
          entrada=len(vectorTags)
          bagOfLines[tag] = entrada
          datos=[]
          datos.append([ciclos,tipo])
          vectorTags.append([tag,datos])


        cnt+=1
        if cnt%10000==0:
            print ("Lineas tratadas: ", cnt)
        if cnt%PERIODOCREAFICHERO==0:
            fichero=salidaFile+"-"+str(numFiles)
            print "Crea fichero", fichero
            numFiles+=1
            RecorreTagAhorroMem(fichero)


def LeeFicheroAhorroMem3():
  print ("LEE FICHERO CON AHORR MEMORIA 3")

  fp=open(traceFile, "r")
  cnt = 0
  numFiles=0
  line=fp.readline()
  while line:
#        print ("line {} contents {}".format(cnt,line))
        cols = line.split(" ")
        ciclos = cols[0]
        tag = cols[2]
        tipo = cols[1]
#        print "Linea:", cnt, " Ciclos:", ciclos, " Tag:", tag, " Tipo:", tipo
        fin=0
        # busca tag en la lista
        if tag in bagOfLines:
          entrada=bagOfLines[tag]
          tagT,datosT = vectorTags[entrada]
          datosT.append([ciclos,tipo])
        else:
          entrada=len(vectorTags)
          bagOfLines[tag] = entrada
          datos=[]
          datos.append([ciclos,tipo])
          vectorTags.append([tag,datos])


        cnt+=1
        if cnt%10000==0:
            print ("Lineas tratadas: ", cnt)
        if cnt%PERIODOCREAFICHERO==0:
            fichero=salidaFile+"-"+str(numFiles)
            print "Crea fichero", fichero
            numFiles+=1
            RecorreTagAhorroMem(fichero)

        line=fp.readline()

  fp.close()






parser = OptionParser()
parser.add_option("--ficheroTraza",action="store",dest="traceF",default="NONE",
            help="name of trace file")

parser.add_option("-s","--ficheroSalida",action="store",dest="salidaF",default="NONE",
            help="name of folder in which to generate experiment config")


(options,args) = parser.parse_args(sys.argv[1:])

salidaFile = options.salidaF
traceFile = options.traceF



print ("Fichero Traza:" , traceFile)
print ("Fichero Salida:" , salidaFile)
if traceFile=="NONE" or salidaFile=="NONE":
    print ("nvt2out.py --ficheroTraza=FicheroTraza --ficheroSalida=FicheroSalida")
    sys.exit(0)

if not os.path.isfile(traceFile):
    print ("File ", traceFile, " no existe")
    sys.exit(0)

tFile = file(traceFile, "r")

# Diccionario
bagOfLines={}

# Lista (ahorro memoria)
#vectorTags=[]

# Uso blist
vectorTags=blist([])

#Version con Diccionario y mucho consumo de memoria (poco tiempo)
#LeeFichero()
#RecorreTag(salidaFile)

#Version con listas y poco consumo de memoria (mucho tiempo). Muchisimo tiempo.
#LeeFicheroAhorroMem()
#RecorreTagAhorroMem(salidaFile)

#Version con listas y poco consumo de memoria. Uso blist. Rapido pero necesita mucha memoria
LeeFicheroAhorroMem3()
RecorreTagAhorroMem(salidaFile)

sys.exit(0)




