#!/usr/bin/python

import sys
import os
import shutil
from optparse import OptionParser
from blist import blist
import re
import common


PERIODOCREAFICHERO=20000000

# defino la ventana espacial. P.ej. 4096 son 12 bits y considero las 4096 posiciones
# por delante y por detras de la posicion actual para considerar localidad espacial
# VentanaEspacial indica el valor para el primer histograma y tambien lo que se
# suma para los siguientes histogramas
VentanaEspacial=2048
NumHistos=2

# Defino la ventana temporal para considerar que hay localidad espacial basada en la
# anterior ventana espacial. El histograma incluira multiplos de esta ventana temporal
# hasta TAMHISTOESPACIAL
VentanaTemporal=5000
TAMHISTOESPACIAL=10


# Comprueba que el ultimo elemento esta a una distancia temporal
# mayor o igual a VentanaTemporal*TAMHISTOESPACIAL+ciclosI ciclos
def checkBagOfLines(fp, ciclosI):
  
  ultimo=len(bagOfLines)
  ciclos,tag=bagOfLines[ultimo-1]
  continua=0
  while ciclos<(VentanaTemporal*TAMHISTOESPACIAL+ciclosI) or continua==1:
    continua=0
    line=fp.readline()
    if not(line):
      break
    cols=line.split(" ")
    cic=cols[0]
    ciclos=int(cic)
    tipo=cols[1]
    tg=cols[2]
    tag=int(tg,0)
    if tipo != "RE":
      bagOfLines.append([ciclos, tag])
    else:
      continua=1
#    print " ", ciclos




# Devuelve el numero de lineas que hay en bagOfLines cuya distancia espacial sea menor que
# VentanaEspacial y que se encuentren a menos distancia temporal de distTemp
def checkNumLin(distTemp, ciclosI, tagI, distEsp):
    cnt=0
    for i in range(1,len(bagOfLines)-1):
      ciclos,tag=bagOfLines[i]
      if tag!=tagI and abs(tag-tagI)<distEsp and (ciclos-ciclosI)<distTemp:
        cnt=cnt+1

    return cnt

#
#
#
# Leo fichero y genero histoEspacial
# Muy lento. Funciona hasta 100000 lineas. Luego empieza a tardar siglos
def LeeFicheroYGeneraStat():
  print "Lee nvt y genera histoEspacial"

  LineasL=0

  for histo in range (0,NumHistos):
    for i in range (0,TAMHISTOESPACIAL):
      histoEspacial[histo][i]=0

  with open(traceFile) as fp:

    # Lectura adelantada
    line=fp.readline()
    cols = line.split(" ")
    cic = cols[0]
    ciclosI=int(cic)
    tg = cols[2]
    tagI=int(tg,0)
    tipo = cols[1]
    bagOfLines.append([ciclosI, tagI])


    # bucle principal
    while len(bagOfLines)>0:

      ciclosI,tagI=bagOfLines[0]
#      print "len: ", len(bagOfLines)
      checkBagOfLines(fp, ciclosI)


      for histo in range(0,NumHistos):
        for i in range(1,TAMHISTOESPACIAL+1):
          numlin=checkNumLin(i*VentanaTemporal, ciclosI, tagI, (histo+1)*VentanaEspacial)
#          print "Numlin:", numlin
          histoEspacial[histo][i-1]+=numlin

      bagOfLines.pop(0)

      LineasL=LineasL+1
      if LineasL%10000 == 0:
        print "LineasL:", LineasL
#      sys.exit(0)

  return LineasL

def imprimeFicheroStat(LineasLeidas):

  for histo in range(0,NumHistos):
    string="HistogramaLocalidadEspacial (PasoDeVentTemp: " +str(VentanaTemporal)+ " Ultimo: "+str(VentanaTemporal*TAMHISTOESPACIAL)+" VentanaEspacial: "+ str(VentanaEspacial*(histo+1))+" ) "
    for i in range(0,TAMHISTOESPACIAL):
      valor=int(float(histoEspacial[histo][i])/float(LineasLeidas))
      string=string+str(valor)+" " 
#    string=string+str(histoEspacial[i])+" " 

    salidaS.write(string)
    salidaS.write("\n")







parser = OptionParser()
parser.add_option("--ficheroTraza",action="store",dest="traceF",default="NONE",
            help="name of trace file")

parser.add_option("-s","--ficheroSalida",action="store",dest="salidaF",default="NONE",
            help="name of temporal stat file")


(options,args) = parser.parse_args(sys.argv[1:])

salidaFile = options.salidaF
traceFile = options.traceF



print ("Fichero Traza:" , traceFile)
print ("Fichero Salida:" , salidaFile)
if traceFile=="NONE" or salidaFile=="NONE":
    print ("nvt2statS.py --ficheroTraza=FicheroTraza --ficheroSalida=FicheroSalidaStatS")
    sys.exit(0)

if not os.path.isfile(traceFile):
    print ("File ", traceFile, " no existe")
    sys.exit(0)

tFile = file(traceFile, "r")
salidaS = file(salidaFile, "w")

# Diccionario
bagOfLines=[]


# Histograma espacial
histoEspacial={}
for i in range(0,NumHistos):
  histoEspacial[i]={}

#
LineasLeidas=LeeFicheroYGeneraStat()
imprimeFicheroStat(LineasLeidas)

sys.exit(0)




