#!/usr/bin/python

import sys
import os
import shutil
from optparse import OptionParser
from blist import blist
import re
import common


PERIODOCREAFICHERO=20000000

TAMHISTOREPE=4000

TAM_HISTO_DISTT=2000000000
PASOS_HISTO_DISTT=500000

UMBRALAR=200  # num de repeticiones para generar el histograma de distancia AR

#
# Funciones de analisis
#


#
#
# Leo fichero e integro en bagOfLines
# Rapidisimo pero ocupa mucha memoria
def LeeFichero():
  print "Leyendo fichero ", datFile
  with open(datFile) as fp:
    cnt = 0
    for line in fp:
#        print ("line {} contents {}".format(cnt,line))
        cols = line.split(" ")
        tam = len(cols)-2  # uno lo quitamos por el barra-n y otro por tag
        tag = cols[0]
        lista=[]
        for i in range(1,tam,2):
          ciclos = cols[i]
          tipo = cols[i+1]
          lista.append([ciclos,tipo])
#          print " ciclos:", ciclos, " tipo:", tipo
        bagOfLines.append([tag,lista])

        cnt+=1

def echo():
    for i in range(0, len(bagOfLines)):
        tag,lista=bagOfLines[i]
        string=tag
        for j in range(0,len(lista)):
          ciclos,tipo=lista[j]
          string=string+" "+ciclos+" "+tipo
        print string

#
# Toma una lista y elimina todos los elementos RE
def EliminaRE(lista):
    for ciclos,op in lista:
        if op=="RE":
            lista.remove([ciclos,op])

def buscaRE(lista):
    cnt=0;
    for ciclos,op in lista:
        if op=="RE":
            cnt=cnt+1

    return cnt

def histogramaRepeticionRE():
    print "Generando histograma repeticion reemplazos"
    # Inicializacion histograma
    for i in range(0,TAMHISTOREPE):
        histoRepeRE[i]=0

    for i in range(0, len(bagOfLines)):
        tag,lista=bagOfLines[i]
        numRE=buscaRE(lista)
#        print "NumREs: ", numRE
# La posicion 0 indica el numero de lineas sin reemplazo, la 1 con 1 reemplazo, etc
        if numRE < TAMHISTOREPE-1:
          histoRepeRE[numRE]+=1
        else:
          histoRepeRE[TAMHISTOREPE-1]+=1

def histogramaRepeticion():
    print "Generando histograma repeticion"
    # Inicializacion histograma
    for i in range(1,TAMHISTOREPE):
        histoRepe[i]=0

    for i in range(0, len(bagOfLines)):
        tag,lista=bagOfLines[i]
        EliminaRE(lista)
#        string=tag
        tam=len(lista)
#        string=string+" repe:"+str(tam)
#        print string
        if tam >0:
          if tam < TAMHISTOREPE-1:
            histoRepe[tam]+=1
          else:
            histoRepe[TAMHISTOREPE-1]+=1

def printHistogramaRepeticionRE():
    string="HistogramaRepeticionRE: (Ultimo: "+str(TAMHISTOREPE)+" +) "
    for i in range(0,TAMHISTOREPE):
      string=string+str(histoRepeRE[i])+" "

    salidaS.write(string)
    salidaS.write("\n")


def printHistogramaRepeticion():
    string="HistogramaRepeticion: (Ultimo: "+str(TAMHISTOREPE)+" +) "
    for i in range(1,TAMHISTOREPE):
      string=string+str(histoRepe[i])+" "

    salidaS.write(string)
    salidaS.write("\n")

# Histograma de distancia temporal entre dos accesos consecutivos a la misma linea en los reemplazos
#
# Dos histogramas:
# - Antes: distancia temporal desde la ultima operacion y el reemplazo
# - Despues: distancia temporal desde el reemplazo a la siguiente operacion (si existe)
def histogramaDistTemporalRE():
    print "Generando histograma distancia temporal reemplazos"
    NumEle=TAM_HISTO_DISTT/PASOS_HISTO_DISTT
    # Inicializacion histograma
    for i in range(0,NumEle):
        histoDistTREAntes[i]=0
        histoDistTREDespues[i]=0

    cnt=0
    for i in range(0, len(bagOfLines)):
        tag,lista=bagOfLines[i]
        cnt+=1
        if cnt%1000000==0:
          print "Cnt: ",cnt
        tam=len(lista)
        bandera=False
        j=1
        while tam>1 and bandera==False:
          ciclos2,tipo2=lista[j]
          # primero hacemos que j apunte a una operacion de reemplazo
          if tipo2!="RE":
            j+=1
            if j>=tam:
                bandera=True
          else:  # j apunta a una operacion de reemplazo
            ciclos1,tipo1=lista[j-1]
            if tam-1>=j+1:
                ciclos3,tipo3=lista[j+1]
            else:
                ciclos3,tipo3=0,"-"
     #
     #Calculamos DifAntes
            try:
              difAntes=long(ciclos2)-long(ciclos1)
            except ValueError:
                print "ValueError en ciclos antes. tag: ",tag
                difAntes=0
                break
            difAntes=difAntes/PASOS_HISTO_DISTT
#            print "dif:", dif
            if difAntes>=0 and difAntes<NumEle-1:
                histoDistTREAntes[difAntes]+=1
            elif difAntes>=0:
                histoDistTREAntes[NumEle-1]+=1
            else:
                print "Ciclos desordenados en difAntes. tag: ", tag
     #
     #Calculamos DifDespues
            if ciclos3>0:
              try:
                difDespues=long(ciclos3)-long(ciclos2)
              except ValueError:
                  print "ValueError en ciclos despues. tag: ",tag
                  difDespues=0
                  break
              difDespues=difDespues/PASOS_HISTO_DISTT
#            print "dif:", dif
              if difDespues>=0 and difDespues<NumEle-1:
                  histoDistTREDespues[difDespues]+=1
              elif difDespues>=0:
                  histoDistTREDespues[NumEle-1]+=1
              else:
                  print "Ciclos desordenados en difDespues. tag: ", tag

            j+=1
            if j>=tam:
                bandera=True


def printHistogramaDistTemporalRE():
    NumEle=TAM_HISTO_DISTT/PASOS_HISTO_DISTT
    string="HistogramaDistanciaTemporalREAntes (Paso: " +str(PASOS_HISTO_DISTT)+ " Ultimo: "+str(TAM_HISTO_DISTT)+" +) "
    for i in range(0,NumEle):
      string=string+str(histoDistTREAntes[i])+" "

    salidaS.write(string)
    salidaS.write("\n")

    string="HistogramaDistanciaTemporalREDespues (Paso: " +str(PASOS_HISTO_DISTT)+ " Ultimo: "+str(TAM_HISTO_DISTT)+" +) "
    for i in range(0,NumEle):
      string=string+str(histoDistTREDespues[i])+" "

    salidaS.write(string)
    salidaS.write("\n")

# Histograma de distancia temporal entre dos accesos consecutivos a la misma linea
def histogramaDistTemporal():
    print "Generando histograma distancia temporal"
    NumEle=TAM_HISTO_DISTT/PASOS_HISTO_DISTT
    # Inicializacion histograma
    for i in range(0,NumEle):
        histoDistT[i]=0

    cnt=0
    for i in range(0, len(bagOfLines)):
        tag,lista=bagOfLines[i]
        EliminaRE(lista)
#        string=tag
        cnt+=1
        if cnt%1000000==0:
          print "Cnt: ",cnt
        tam=len(lista)
        if tam>1:
          for j in range(1, tam):
            ciclos2,tipo2=lista[j]
            ciclos1,tipo1=lista[j-1]
            try:
              dif=long(ciclos2)-long(ciclos1)
            except ValueError:
                print "ValueError en ciclos. tag: ",tag
                dif=0
                break
            dif=dif/PASOS_HISTO_DISTT
#            print "dif:", dif
            if dif>=0 and dif<NumEle-1:
                histoDistT[dif]+=1
            elif dif>=0:
                histoDistT[NumEle-1]+=1
            else:
                print "Ciclos desordenados. tag: ", tag
          

def printHistogramaDistTemporal():
    NumEle=TAM_HISTO_DISTT/PASOS_HISTO_DISTT
    string="HistogramaDistanciaTemporal (Paso: " +str(PASOS_HISTO_DISTT)+ " Ultimo: "+str(TAM_HISTO_DISTT)+" +) "
    for i in range(0,NumEle):
      string=string+str(histoDistT[i])+" "

    salidaS.write(string)
    salidaS.write("\n")



# Histograma de distancia temporal entre dos accesos consecutivos a la misma linea
# AR=Alta Repeticion. Solo con lineas con mas de UMBRALAR repeticiones
def histogramaDistTemporalAR():
    print "Generando histograma distancia temporal AR (alta repeticion)"
    NumEle=TAM_HISTO_DISTT/PASOS_HISTO_DISTT
    # Inicializacion histograma
    for i in range(0,NumEle):
        histoDistTAR[i]=0

    cnt=0
    for i in range(0, len(bagOfLines)):
        tag,lista=bagOfLines[i]
        EliminaRE(lista)
#        string=tag
        cnt+=1
        if cnt%1000000==0:
          print "Cnt: ",cnt
        tam=len(lista)
        if tam>UMBRALAR:
          for j in range(1, tam):
            ciclos2,tipo2=lista[j]
            ciclos1,tipo1=lista[j-1]
            try:
              dif=long(ciclos2)-long(ciclos1)
            except ValueError:
                print "ValueError en ciclos. tag: ",tag
                dif=0
                break
            dif=dif/PASOS_HISTO_DISTT
#            print "dif:", dif
            if dif>=0 and dif<NumEle-1:
                histoDistTAR[dif]+=1
            elif dif>=0:
                histoDistTAR[NumEle-1]+=1
            else:
                print "Ciclos desordenados. tag: ", tag
          

def printHistogramaDistTemporalAR():
    NumEle=TAM_HISTO_DISTT/PASOS_HISTO_DISTT
    string="HistogramaDistanciaTemporalAR (Paso: " +str(PASOS_HISTO_DISTT)+ " Ultimo: "+str(TAM_HISTO_DISTT)+" + UmbralReps: "+ str(UMBRALAR)+" ) "
    for i in range(0,NumEle):
      string=string+str(histoDistTAR[i])+" "

    salidaS.write(string)
    salidaS.write("\n")





parser = OptionParser()
parser.add_option("--ficheroOut",action="store",dest="fichO",default="NONE",
            help="name of out file")

parser.add_option("-s","--ficheroStat",action="store",dest="salidaS",default="NONE",
            help="name of folder in which to generate stat result file")


(options,args) = parser.parse_args(sys.argv[1:])

salidaStat = options.salidaS
datFile = options.fichO



if salidaStat=="NONE" or datFile=="NONE":
    print ("nvt2out.py --ficheroOut=FicheroOut.out --ficheroStat=FicheroEstadisticas.stat")
    sys.exit(0)

if not os.path.isfile(datFile):
    print ("File ", datFile, " no existe")
    sys.exit(0)

print ("Fichero datos out:" , datFile)
print ("Fichero Salida:" , salidaStat)

salidaS = file(salidaStat, "w")

# Diccionario
bagOfLines=[]

# Uso blist
#bagOfLines=blist([])

# Histogramas
histoRepe={}
histoRepeRE={}
histoDistT={}
histoDistTREAntes={}
histoDistTREDespues={}
histoDistTAR={}

#Version con Diccionario y mucho consumo de memoria (poco tiempo)
LeeFichero()
#echo()

histogramaRepeticionRE()
printHistogramaRepeticionRE()

histogramaDistTemporalRE()
printHistogramaDistTemporalRE()

histogramaRepeticion()
printHistogramaRepeticion()
histogramaDistTemporal()
printHistogramaDistTemporal()
histogramaDistTemporalAR()
printHistogramaDistTemporalAR()


sys.exit(0)




